diff --git a/game/core/src/main/java/net/minecraft/core/entity/IItemHolding.java b/game/core/src/main/java/net/minecraft/core/entity/IItemHolding.java
new file mode 100644
index 000000000..cb6dc5d50
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/IItemHolding.java
@@ -0,0 +1,12 @@
+package net.minecraft.core.entity;
+
+import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
+
+public interface IItemHolding {
+    @Nullable ItemStack getHeldItem();
+
+    void setHeldItem(final @Nullable ItemStack item);
+
+    boolean isLeftHanded();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 9abf2175b..364b45ff6 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -1283,11 +1283,6 @@ public abstract class Mob extends Entity
         return 4;
     }
 
-    public ItemStack getHeldItem()
-    {
-        return null;
-    }
-
     @Override
 	public void handleEntityEvent(byte byte0, float attackedAtYaw)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index 1bae21f1e..fd68f598f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -240,7 +240,7 @@ public class MobFireflyCluster extends MobFlying
             return false;
 
         int blockLight = world.getBlockLightValue(x, y, z);
-        if(world.getCurrentWeather() != null && world.getCurrentWeather().doMobsSpawnInDaylight)
+        if(world.getCurrentWeather() != null && world.getCurrentWeather().isMobDaylightSpawnAllowed())
             blockLight = blockLight/2;
 
         return  blockLight <= 4 && (Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && world.checkIfAABBIsClear(bb.grow(-2f, 0f, -2f));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index fbf3fcfde..938d8d96e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -2,6 +2,7 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
@@ -20,10 +21,11 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
-public class MobWolf extends MobAnimal
+public class MobWolf extends MobAnimal implements IItemHolding
 {
     public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
     static {
@@ -79,11 +81,11 @@ public class MobWolf extends MobAnimal
     @Override
     public void spawnInit() {
         if(random.nextInt(25 /*Used to be 100, but I think having it that high would make it excessively rare*/) == 0){
-            setWolfHeldItem(new ItemStack(Items.RECORD_DOG, 1));
+            setHeldItem(new ItemStack(Items.RECORD_DOG, 1));
         }
     }
 
-    public ArmorMaterial getArmorMaterial() {
+    public @Nullable ArmorMaterial getArmorMaterial() {
         ArmorMaterial material = null;
         String name = entityData.getString(DATA_ARMOR_MATERIAL);
         for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
@@ -168,9 +170,9 @@ public class MobWolf extends MobAnimal
         tag.putBoolean("Angry", isWolfAngry());
         tag.putBoolean("Sitting", isWolfSitting());
 
-        if(getWolfHeldItem() != null) {
+        if(getHeldItem() != null) {
             CompoundTag heldItemNBT = new CompoundTag();
-            getWolfHeldItem().writeToNBT(heldItemNBT);
+            getHeldItem().writeToNBT(heldItemNBT);
 
             tag.putCompound("HeldItem", heldItemNBT);
         }
@@ -195,7 +197,7 @@ public class MobWolf extends MobAnimal
             ItemStack stack = ItemStack.readItemStackFromNbt(heldItemStack);
             if (stack != null)
             {
-                setWolfHeldItem(stack);
+                setHeldItem(stack);
             }
         }
 
@@ -285,7 +287,7 @@ public class MobWolf extends MobAnimal
     {
         if(getHeldItem() != null && getHeldItem().stackSize > 0) {
         	dropItem(getHeldItem(), 0.0f);
-            setWolfHeldItem(null);
+            setHeldItem(null);
         }
         if (armor != null && armor.stackSize > 0){
             dropItem(armor, 0);
@@ -307,6 +309,10 @@ public class MobWolf extends MobAnimal
             }
         }
 
+        if (isWolfSitting()) {
+            setTarget(null);
+        }
+
         if(!hasAttacked && !hasPath() && isWolfTamed() && vehicle == null)
         {
             Player entityplayer = world.getPlayerEntityByUUID(getWolfOwner());
@@ -332,7 +338,7 @@ public class MobWolf extends MobAnimal
                 }
             }
         }
-        ItemStack heldItemSlot = getWolfHeldItem();
+        ItemStack heldItemSlot = getHeldItem();
         if((heldItemSlot == null || heldItemSlot.itemID <= 0)) {
             List<EntityItem> triedItems = new ArrayList<>();
             List<EntityItem> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
@@ -397,12 +403,6 @@ public class MobWolf extends MobAnimal
         }
     }
 
-    @Override
-    public ItemStack getHeldItem()
-    {
-        return getWolfHeldItem();
-    }
-
     @Override
 	public void tick()
     {
@@ -412,11 +412,11 @@ public class MobWolf extends MobAnimal
         if(entitiesNearWolf != null && !entitiesNearWolf.isEmpty() && isAlive())
         {
             for (Entity entity : entitiesNearWolf) {
-                if(entity instanceof EntityItem && (this.getWolfHeldItem() == null || this.getWolfHeldItem().getItem() == null)){
+                if(entity instanceof EntityItem && (this.getHeldItem() == null || this.getHeldItem().getItem() == null)){
                     EntityItem entityItem = (EntityItem) entity;
 
                     if (entityItem.item != null && entityItem.item.stackSize > 0) {
-                        setWolfHeldItem(entityItem.item.copy());
+                        setHeldItem(entityItem.item.copy());
                         entityItem.item.stackSize = 0;
                         entity.outOfWorld();
 
@@ -677,7 +677,11 @@ public class MobWolf extends MobAnimal
     {
         if(!fireImmune)
         {
-            float protection = 1.0f - getArmorMaterial().getProtection(DamageType.FIRE);
+            float protection = 0;
+            ArmorMaterial material;
+            if ((material = getArmorMaterial()) != null) {
+                protection = 1.0f - material.getProtection(DamageType.FIRE);
+            }
             protection = Math.max(protection, 0.01f);
             hurt(null, 4, DamageType.FIRE);
             remainingFireTicks = (int) (80 + 520 * protection);
@@ -689,7 +693,11 @@ public class MobWolf extends MobAnimal
     {
         if(!fireImmune)
         {
-            float protection = 1.0f - getArmorMaterial().getProtection(DamageType.FIRE);
+            float protection = 0;
+            ArmorMaterial material;
+            if ((material = getArmorMaterial()) != null) {
+                protection = 1.0f - material.getProtection(DamageType.FIRE);
+            }
             protection = Math.max(protection, 0.01f);
             hurt(null, 1, DamageType.FIRE);
             remainingFireTicks = (int) (40 + 260 * protection);
@@ -745,7 +753,7 @@ public class MobWolf extends MobAnimal
                 			player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                 		}                		
                 	}
-                    heal(((ItemFood)Items.FOOD_PORKCHOP_RAW).getHealAmount());
+                    heal(itemfood.getHealAmount());
                     return true;
                 }
             }
@@ -770,11 +778,11 @@ public class MobWolf extends MobAnimal
             {
                 if(!world.isClientSide)
                 {
-                    ItemStack heldItemSlot = getWolfHeldItem();
+                    ItemStack heldItemSlot = getHeldItem();
                     if(isWolfSitting() && heldItemSlot != null && heldItemSlot.getItem() != null && heldItemSlot.itemID > 0 && !player.isSneaking()) {
                     	player.inventory.insertItem(heldItemSlot, true);
                     	if(heldItemSlot.stackSize <= 0) {
-                    		setWolfHeldItem(null);
+                    		setHeldItem(null);
                     	}
                     }else {
                         setWolfSitting(!isWolfSitting());
@@ -878,14 +886,6 @@ public class MobWolf extends MobAnimal
         }
     }
 
-    public ItemStack getWolfHeldItem(){
-        return entityData.getItemStack(DATA_HELD_ITEM);
-    }
-
-    public void setWolfHeldItem(ItemStack itemStack){
-        entityData.set(DATA_HELD_ITEM, itemStack);
-    }
-
     public boolean isWolfTamed()
     {
         return (entityData.getByte(DATA_GENERIC_FLAGS) & MASK_TAMED) != 0;
@@ -902,4 +902,19 @@ public class MobWolf extends MobAnimal
             entityData.set(DATA_GENERIC_FLAGS, (byte) (data & ~MASK_TAMED));
         }
     }
+
+    @Override
+    public @Nullable ItemStack getHeldItem() {
+        return this.entityData.getItemStack(DATA_HELD_ITEM);
+    }
+
+    @Override
+    public void setHeldItem(@Nullable ItemStack item) {
+        this.entityData.set(DATA_HELD_ITEM, item);
+    }
+
+    @Override
+    public boolean isLeftHanded() {
+        return false;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index cfc4e51e6..5bec715fd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -4,7 +4,6 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
-import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
@@ -150,9 +149,6 @@ public class MobGhast extends MobFlying
             {
             	targetedEntity = null;
             }
-            if (targetedEntity != null && targetedEntity.vehicle instanceof MobGhastVehicle) {
-                targetedEntity = null;
-            }
             if(targetedEntity != null)
             {
                 aggroCooldown = 20;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index 3240cecb2..f9e78d9d0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -153,7 +153,7 @@ public abstract class MobMonster extends MobPathfinder
             return false;
 
         int blockLight = world.getBlockLightValue(blockX, blockY, blockZ);
-        if(world.getCurrentWeather() != null && world.getCurrentWeather().doMobsSpawnInDaylight)
+        if(world.getCurrentWeather() != null && world.getCurrentWeather().isMobDaylightSpawnAllowed())
             blockLight = blockLight/2;
 
         return blockLight <= 4 && super.canSpawnHere();
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
index e73ef804b..ad76c65fa 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
@@ -5,6 +5,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.entity.IArmorWearing;
+import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.enums.IArmorShape;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
@@ -12,21 +13,17 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public abstract class MobMonsterArmored<T extends IArmorShape> extends MobMonster implements IArmorWearing<T> {
-    private static final int DATA_ARMOR_START = 24;
+public abstract class MobMonsterArmored<T extends IArmorShape>
+    extends MobMonster
+    implements IArmorWearing<T>, IItemHolding {
+
+    private static final int DATA_ITEM_HELD = 24;
+    private static final int DATA_ARMOR_START = 25;
 
     public MobMonsterArmored(final @Nullable World world) {
         super(world);
     }
 
-    @Override
-    protected void defineSynchedData() {
-        super.defineSynchedData();
-        for (int i = 0; i < getNumArmorSlots(); i++) {
-            this.entityData.define(DATA_ARMOR_START + i, null, ItemStack.class);
-        }
-    }
-
     @Override
     public @Nullable ItemStack getItemInArmorSlot(final @NotNull T slot) {
         return this.entityData.getItemStack(DATA_ARMOR_START + slot.getSlotIndex());
@@ -37,6 +34,30 @@ public abstract class MobMonsterArmored<T extends IArmorShape> extends MobMonste
         this.entityData.set(DATA_ARMOR_START + slot.getSlotIndex(), item);
     }
 
+    @Override
+    public @Nullable ItemStack getHeldItem() {
+        return this.entityData.getItemStack(DATA_ITEM_HELD);
+    }
+
+    @Override
+    public void setHeldItem(@Nullable ItemStack item) {
+        this.entityData.set(DATA_ITEM_HELD, item);
+    }
+
+    @Override
+    public boolean isLeftHanded() {
+        return false;
+    }
+
+    @Override
+    protected void defineSynchedData() {
+        super.defineSynchedData();
+        this.entityData.define(DATA_ITEM_HELD, null, ItemStack.class);
+        for (int i = 0; i < getNumArmorSlots(); i++) {
+            this.entityData.define(DATA_ARMOR_START + i, null, ItemStack.class);
+        }
+    }
+
     @Override
     public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index b9b827d80..14b1ec861 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -4,25 +4,24 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
-import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Random;
-
 public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
 {
+    private static final ItemStack DEFAULT_HELD_ITEM;
+
+    static {
+        DEFAULT_HELD_ITEM = new ItemStack(Items.TOOL_BOW, 1);
+    }
+
     public static final int DATA_ATTACK_TIME = 15;
 
     public MobSkeleton(World world) {
@@ -31,56 +30,6 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
         scoreValue = 500;
         mobDrops.add(new WeightedRandomLootObject(Items.AMMO_ARROW.getDefaultStack(), 0, 2));
         mobDrops.add(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 0, 2));
-
-        Map<ArmorMaterial, Map<HumanArmorShape, Item>> itemsMapMap = new HashMap<>();
-
-        Map<HumanArmorShape, Item> itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_LEATHER);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_LEATHER);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_LEATHER);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_LEATHER);
-        itemsMapMap.put(ArmorMaterial.LEATHER, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_IRON);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_IRON);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_IRON);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_IRON);
-        itemsMapMap.put(ArmorMaterial.IRON, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_GOLD);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_GOLD);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_GOLD);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_GOLD);
-        itemsMapMap.put(ArmorMaterial.GOLD, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_CHAINMAIL);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_CHAINMAIL);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        itemsMapMap.put(ArmorMaterial.CHAINMAIL, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_DIAMOND);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_DIAMOND);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_DIAMOND);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_DIAMOND);
-        itemsMapMap.put(ArmorMaterial.DIAMOND, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_STEEL);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_STEEL);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_STEEL);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_STEEL);
-        itemsMapMap.put(ArmorMaterial.STEEL, itemsMap);
-
-        Random rand = new Random();
-        for (HumanArmorShape shape : HumanArmorShape.values()) {
-            ArmorMaterial mat = ArmorMaterial.getArmorMaterials().get(rand.nextInt(ArmorMaterial.getArmorMaterials().size()));
-            setItemInArmorSlot(shape, new ItemStack(itemsMapMap.get(mat).get(shape)));
-        }
     }
 
     @Override
@@ -107,6 +56,13 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
         entityData.define(DATA_ATTACK_TIME, attackTime, Integer.class);
     }
 
+    @Override
+    public void spawnInit() {
+        super.spawnInit();
+
+        setHeldItem(DEFAULT_HELD_ITEM.copy());
+    }
+
     @Override
 	public void onLivingUpdate()
     {
@@ -120,7 +76,7 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
             float f = getBrightness(1.0F);
             Weather weather;
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                && (weather = world.getCurrentWeather()) != null &&  !weather.isDamp && (weather != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
+                && (weather = world.getCurrentWeather()) != null &&  !weather.isDamp() && (weather != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
@@ -153,12 +109,6 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
         }
     }
 
-    @Override
-	public ItemStack getHeldItem()
-    {
-        return defaultHeldItem;
-    }
-
     @Override
     public int getNumArmorSlots() {
         return HumanArmorShape.values().length;
@@ -172,11 +122,4 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
 
         return HumanArmorShape.values()[index];
     }
-
-    private static final ItemStack defaultHeldItem;
-
-    static
-    {
-        defaultHeldItem = new ItemStack(Items.TOOL_BOW, 1);
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
index c3d8a3283..5b01ff77d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
@@ -57,7 +57,6 @@ public class MobSnowman extends MobMonster
                     {
                         projectileSnowball.damage = 1;
                     }
-                    projectileSnowball.y += 1.4D;
                     double d2 = (entity.y + (double) entity.getHeadHeight()) - 0.2D - projectileSnowball.y;
                     float f1 = MathHelper.sqrt(dX * dX + dZ * dZ) * 0.2F;
                     world.playSoundAtEntity(null, this, "random.bow", 0.5F, 0.4F / (random.nextFloat() * 0.4F + 0.8F));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
index cd9d8345e..22d3f052b 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
@@ -29,56 +29,6 @@ public class MobZombie extends MobMonsterArmored<HumanArmorShape>
         attackStrength = 5;
         scoreValue = 300;
         mobDrops.add(new WeightedRandomLootObject(Items.CLOTH.getDefaultStack(), 0, 2));
-
-        Map<ArmorMaterial, Map<HumanArmorShape, Item>> itemsMapMap = new HashMap<>();
-
-        Map<HumanArmorShape, Item> itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_LEATHER);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_LEATHER);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_LEATHER);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_LEATHER);
-        itemsMapMap.put(ArmorMaterial.LEATHER, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_IRON);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_IRON);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_IRON);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_IRON);
-        itemsMapMap.put(ArmorMaterial.IRON, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_GOLD);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_GOLD);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_GOLD);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_GOLD);
-        itemsMapMap.put(ArmorMaterial.GOLD, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_CHAINMAIL);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_CHAINMAIL);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        itemsMapMap.put(ArmorMaterial.CHAINMAIL, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_DIAMOND);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_DIAMOND);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_DIAMOND);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_DIAMOND);
-        itemsMapMap.put(ArmorMaterial.DIAMOND, itemsMap);
-
-        itemsMap = new HashMap<>();
-        itemsMap.put(HumanArmorShape.BOOTS, Items.ARMOR_BOOTS_STEEL);
-        itemsMap.put(HumanArmorShape.LEGS, Items.ARMOR_LEGGINGS_STEEL);
-        itemsMap.put(HumanArmorShape.CHEST, Items.ARMOR_CHESTPLATE_STEEL);
-        itemsMap.put(HumanArmorShape.HEAD, Items.ARMOR_CHESTPLATE_STEEL);
-        itemsMapMap.put(ArmorMaterial.STEEL, itemsMap);
-
-        Random rand = new Random();
-        for (HumanArmorShape shape : HumanArmorShape.values()) {
-            ArmorMaterial mat = ArmorMaterial.getArmorMaterials().get(rand.nextInt(ArmorMaterial.getArmorMaterials().size()));
-            setItemInArmorSlot(shape, new ItemStack(itemsMapMap.get(mat).get(shape)));
-        }
     }
 
     @Override
@@ -89,7 +39,7 @@ public class MobZombie extends MobMonsterArmored<HumanArmorShape>
             float f = getBrightness(1.0F);
             Weather weather = world.getCurrentWeather();
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                && weather != null && !weather.isDamp && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
+                && weather != null && !weather.isDamp() && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
index 035051a6f..a161e2c91 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
@@ -3,23 +3,32 @@ package net.minecraft.core.entity.monster;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
-public class MobZombieArmored extends MobZombie
+public class MobZombieArmored extends MobZombie implements IItemHolding
 {
     public static final int DATA_BREAK_POINTS = 6;
     public static final int DATA_BREAK_ORDER = 7;
     public static final int DATA_GENERIC_FLAGS = 8;
     public static final int MASK_FLAG_SWORD = 0b0000_0001;
+
+    private static final ItemStack DEFAULT_HELD_ITEM;
+
+    static {
+        DEFAULT_HELD_ITEM = new ItemStack(Items.TOOL_SWORD_IRON, 1);
+    }
+
     public MobZombieArmored(World world)
     {
         super(world);
@@ -54,21 +63,24 @@ public class MobZombieArmored extends MobZombie
     }
 
     @Override
-    public void defineSynchedData(){
+    public void defineSynchedData() {
         super.defineSynchedData();
         entityData.define(DATA_BREAK_POINTS, 0, Integer.class);
         entityData.define(DATA_BREAK_ORDER, (short) 0, Short.class);
         entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
     }
+
     @Override
     public int getMaxHealth(){
         return 40;
     }
+
     @Override
 	public void onLivingUpdate()
     {
         super.onLivingUpdate();
     }
+
     @Override
     public boolean hurt(Entity attacker, int i, DamageType type)
     {
@@ -94,6 +106,7 @@ public class MobZombieArmored extends MobZombie
 
         return result;
     }
+
     public void setArmorBreakPoints(int[] breakPoints){
         int value = breakPoints[0];
         value |=  breakPoints[1] << 6;
@@ -101,10 +114,12 @@ public class MobZombieArmored extends MobZombie
         value |= breakPoints[3] << 18;
         entityData.set(6, value);
     }
+
     public int[] getArmorBreakPoints(){
         int value = entityData.getInt(6);
         return new int[]{value & 0x3F, (value & 0xFC0) >> 6, (value & 0x3_F000) >> 12, (value & 0xFC_0000) >> 18};
     }
+
     public void setArmorBreakOrder(int[] breakPoints){
         short value = (short) breakPoints[0];
         value |= (short) (breakPoints[1] << 2);
@@ -116,6 +131,7 @@ public class MobZombieArmored extends MobZombie
         short value = entityData.getShort(7);
         return new int[]{value & 0x3, (value & 0xC) >> 2, (value & 0x30) >> 4, (value & 0xC0) >> 6};
     }
+
     public void setHoldingSword(boolean flag){
         if (flag) {
             entityData.set(DATA_GENERIC_FLAGS, (byte)(entityData.getByte(DATA_GENERIC_FLAGS) | MASK_FLAG_SWORD));
@@ -157,13 +173,13 @@ public class MobZombieArmored extends MobZombie
 	public ItemStack getHeldItem()
     {
         if(this.isHoldingSword())
-            return defaultHeldItem;
+            return DEFAULT_HELD_ITEM;
         return null;
     }
-    private static final ItemStack defaultHeldItem;
 
-    static
-    {
-        defaultHeldItem = new ItemStack(Items.TOOL_SWORD_IRON, 1);
+    @Override
+    public void setHeldItem(@Nullable ItemStack item) {
+        return;
     }
+
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index f07d24e89..1fa3117c4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -21,6 +21,15 @@ import java.util.List;
 
 public class MobZombiePig extends MobZombie
 {
+    private static final ItemStack DEFAULT_HELD_ITEM;
+
+    static
+    {
+        DEFAULT_HELD_ITEM = new ItemStack(Items.TOOL_SWORD_GOLD, 1);
+    }
+
+    private int angerLevel;
+    private int randomSoundDelay;
 
     public MobZombiePig(World world)
     {
@@ -34,6 +43,13 @@ public class MobZombiePig extends MobZombie
         scoreValue = 500;
     }
 
+    @Override
+    public void spawnInit() {
+        super.spawnInit();
+
+        setHeldItem(DEFAULT_HELD_ITEM.copy());
+    }
+
     @Override
 	public void tick()
     {
@@ -168,19 +184,4 @@ public class MobZombiePig extends MobZombie
 
         return drops;
     }
-
-    @Override
-	public ItemStack getHeldItem()
-    {
-        return defaultHeldItem;
-    }
-
-    private int angerLevel;
-    private int randomSoundDelay;
-    private static final ItemStack defaultHeldItem;
-
-    static 
-    {
-        defaultHeldItem = new ItemStack(Items.TOOL_SWORD_GOLD, 1);
-    }
 }
